package me.demon.market.Gui;

import me.Demon.DemonPlugin.DemonAPI;
import me.demon.market.MGui.Market_Default;
import me.demon.market.Util.uItems;
import me.demon.market.main;
import org.bukkit.Bukkit;
import org.bukkit.Material;
import org.bukkit.Sound;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.inventory.InventoryClickEvent;
import org.bukkit.event.inventory.InventoryType;
import org.bukkit.inventory.Inventory;
import org.bukkit.inventory.ItemFlag;
import org.bukkit.inventory.ItemStack;
import org.bukkit.inventory.meta.ItemMeta;

import java.util.ArrayList;
import java.util.List;
import java.util.Objects;

public class AdminGui implements Listener {

    @EventHandler
    public void onclick(InventoryClickEvent e) {
        Player p = (Player) e.getWhoClicked();
        if (e.getInventory().getType() == InventoryType.CHEST && e.getView().getTitle().contains("§c§l拼刀刀§7[§a§l管理商品§7]")) {
            e.setCancelled(true);
            if (e.getRawSlot() == 33) {
                Market_Default.OpenGui(p, 1);
                p.playSound(p.getLocation(), Sound.BLOCK_LEVER_CLICK, 1, 2);
            }
            if (e.getRawSlot() >= 0 && e.getRawSlot() < 27) {
                p.closeInventory();
                if (!DemonAPI.itemIsNull(e.getCurrentItem())) {
                    ItemStack item = e.getCurrentItem();
                    ItemMeta meta = item.getItemMeta();
                    String itemName = meta.getDisplayName();
                    String key = itemName.split("#")[1].replace("§7)", "");
                    if (main.DataG.getString("Items." + key + ".Item") != null) {
                        ItemStack items = main.DataG.getItemStack("Items." + key + ".Item");
                        p.getInventory().addItem(items);
                        main.DataG.set("Items." + key, null);
                        main.saveDataStatsConfig();
                        main.KeyList.remove(key);
                        p.sendMessage(main.prefix + "成功下架该商品！");
                        p.playSound(p.getLocation(), Sound.BLOCK_LEVER_CLICK, 1, 2);
                    } else {
                        p.closeInventory();
                        p.sendMessage(main.prefix + "很抱歉,其他玩家抢先一步拍走了这个珍贵的商品!");
                        p.playSound(p.getLocation(), Sound.BLOCK_LEVER_CLICK, 1, 2);
                    }
                }
            }
        }
    }

    public static void OpenGui(Player p) {
        Inventory inv = Bukkit.createInventory(null, 36, "§c§l拼刀刀§7[§a§l管理商品§7]");
        for (int i = 27; i < 36; i++) {
            inv.setItem(i, uItems.glass("§7[[§a▧§c▧§a▧§7]]"));
        }
        inv.setItem(29, 操作指引());
        inv.setItem(33, uItems.返回上一页());
        for (int i = 0; i < main.KeyList.size(); i++) {
            String key = main.KeyList.get(i);
            String str = "Items." + key + ".";
            String Seller = main.DataG.getString(str + "Seller");
            if (Seller.equalsIgnoreCase(p.getName())) {
                int Money = main.DataG.getInt(str + "Money");
                String ShelfTime = main.DataG.getString(str + "ShelfTime");
                ItemStack items = main.DataG.getItemStack(str + "Item");
                inv.addItem(ShopItemsEdit(Seller, items, key, Money, ShelfTime));
            }
        }
        p.openInventory(inv);
    }

    public static ItemStack ShopItemsEdit(String playName, ItemStack items, String Key, int Price, String ShelfTime) {
        String money = "§6$" + Price + "金币";
        ItemStack item = items.clone();
        ItemMeta meta = item.getItemMeta();
        assert meta != null;
        if (!DemonAPI.itemIsName(item)) {
            meta.setDisplayName(item.getItemMeta().getDisplayName() + "§7(§r§f#" + Key + "§7)");
        } else {
            String itemName = uItems.getItemName(item);
            meta.setDisplayName(itemName + "§7(§r§f#" + Key + "§7)");
        }
        List<String> lore = new ArrayList<>();
        if (!DemonAPI.itemIsLore(item)) {
            lore.addAll(Objects.requireNonNull(Objects.requireNonNull(items.getItemMeta()).getLore()));
        }
        lore.add("§7-------------------------");
        lore.add("§a§l★§7出售价格: " + money);
        lore.add("§a§l★§7出售数量: §f" + item.getAmount() + "个");
        lore.add("§a§l★§7物品主人: §f" + playName);
        lore.add("§a§l★§7下价时间: §f" + ShelfTime);
        lore.add(" ");
        lore.add("§e§l★§7左键点击下架此商品");
        meta.setLore(lore);
        meta.addItemFlags(ItemFlag.HIDE_ATTRIBUTES);
        meta.addItemFlags(ItemFlag.HIDE_UNBREAKABLE);
        meta.addItemFlags(ItemFlag.HIDE_POTION_EFFECTS);
        item.setItemMeta(meta);
        return item;
    }

    public static ItemStack 操作指引() {
        ItemStack item = new ItemStack(Material.BOOK_AND_QUILL);
        ItemMeta meta = item.getItemMeta();
        meta.setDisplayName("§8« §e管理指南 §8»");
        List<String> lore = new ArrayList<>();
        lore.add("§a§l★ §7点击上方的商品 §a§l★");
        lore.add("§a§l★ §7下架后返回背包 §a§l★");
        meta.setLore(lore);
        item.setItemMeta(meta);
        return item;
    }

}
