package me.demon.market;

import me.Demon.DemonPlugin.DemonAPI;
import me.demon.market.Gui.AdminGui;
import me.demon.market.Gui.CategoryCreate;
import me.demon.market.Gui.ItemTypeGui;
import me.demon.market.MGui.*;
import me.demon.market.Util.MkEvant;
import org.bukkit.Bukkit;
import org.bukkit.Sound;
import org.bukkit.command.Command;
import org.bukkit.command.CommandSender;
import org.bukkit.configuration.file.FileConfiguration;
import org.bukkit.configuration.file.YamlConfiguration;
import org.bukkit.entity.Player;
import org.bukkit.event.Listener;
import org.bukkit.inventory.ItemStack;
import org.bukkit.plugin.java.JavaPlugin;

import java.io.File;
import java.io.IOException;
import java.text.SimpleDateFormat;
import java.util.*;

public class main extends JavaPlugin implements Listener {

    public static String pluginName = "魂式市场";
    public static main plugin;
    public static String prefix = "§7[§6拼刀刀§7] §f";
    public static HashMap<String, List<String>> getItemType = new HashMap<>();
    public static List<String> KeyList = new ArrayList<>();
    public static List<String> BlackNoItemList = new ArrayList<>();

    @Override
    public void onEnable() {
        plugin = this;
        saveDefaultConfig();
        BlackNoItemList.addAll(getConfig().getStringList("Settings.BlackNoItemList"));
        if (main.DataG.getConfigurationSection("Items") != null) {
            KeyList.addAll(Objects.requireNonNull(main.DataG.getConfigurationSection("Items")).getKeys(false));
            Bukkit.getConsoleSender().sendMessage("§6[" + pluginName + "] §f载入市场物品: " + KeyList.size() + "件");
        }
        int type_a = 0;
        for (String Type_Name : CategoryG.getKeys(false)) {
            List<String> item_list = CategoryG.getStringList(Type_Name);
            type_a = type_a + item_list.size();
            getItemType.put(Type_Name, item_list);
        }
        Bukkit.getConsoleSender().sendMessage("§6[" + pluginName + "] §f载入分类物品: " + type_a + "件");
        Bukkit.getServer().getPluginManager().registerEvents(new Market_Default(), plugin);
        Bukkit.getServer().getPluginManager().registerEvents(new Market_方块(), plugin);
        Bukkit.getServer().getPluginManager().registerEvents(new Market_防具(), plugin);
        Bukkit.getServer().getPluginManager().registerEvents(new Market_武器(), plugin);
        Bukkit.getServer().getPluginManager().registerEvents(new Market_食物(), plugin);
        Bukkit.getServer().getPluginManager().registerEvents(new Market_工具(), plugin);
        Bukkit.getServer().getPluginManager().registerEvents(new Market_交通(), plugin);
        Bukkit.getServer().getPluginManager().registerEvents(new Market_药水(), plugin);
        Bukkit.getServer().getPluginManager().registerEvents(new Market_杂项(), plugin);
        Bukkit.getServer().getPluginManager().registerEvents(new Market_红石(), plugin);

        Bukkit.getServer().getPluginManager().registerEvents(new AdminGui(), plugin);
        Bukkit.getServer().getPluginManager().registerEvents(new ItemTypeGui(), plugin);
        Bukkit.getServer().getPluginManager().registerEvents(new CategoryCreate(), plugin);
        Bukkit.getConsoleSender().sendMessage("§6[" + pluginName + "] §f插件加载成功！");
        Bukkit.getConsoleSender().sendMessage("§6[" + pluginName + "] §f作者QQ:1763917516");
        Bukkit.getScheduler().scheduleSyncRepeatingTask(this, new Runnable() {
            @Override
            public void run() {
                TimeCheckRunnable.Check_Market_Time();
            }
        }, 0, 1200L);
    }

    public void onDisable() {
        KeyList.clear();
        Bukkit.getConsoleSender().sendMessage("§6[" + pluginName + "] §f市场数据已保存。");
        Bukkit.getConsoleSender().sendMessage("§6[" + pluginName + "] §f插件已安全卸载！");
    }

    public static String MinutesToCountdown(int Minutes) {
        if (Minutes == 0) {
            return "0天0时0分";
        }
        int day = 24 * 60;
        int hour = 60;
        int remainder = 0;
        int integer = 0;
        StringBuilder sb = new StringBuilder();
        integer = Minutes / day;
        remainder = Minutes % day;
        sb.append(integer).append("天");
        integer = remainder / hour;
        remainder = remainder % hour;
        sb.append(integer).append("时").append(remainder).append("分");
        return sb.toString();
    }

    public boolean onCommand(CommandSender sender, Command cmd, String Command, String[] args) {
        if (Command.equalsIgnoreCase("gsitem") && sender.isOp()) {
            if (args.length == 0) {
                sender.sendMessage("");
                sender.sendMessage("§e------- ======= §6全球贸易市场 §e======= -------");
                sender.sendMessage("§2/gsitem [分类名] §f- §2设置物品分类");
                sender.sendMessage("§e------- ======= §6全球贸易市场 §e======= -------");
            }
            if (args.length == 1) {
                Player p = (Player) sender;
                CategoryCreate.OpenItemsGui(p, args[0]);
            }
            return true;
        }
        if (Command.equalsIgnoreCase("pdd")) {
            if (args.length == 0) {
                Player p = (Player) sender;
                Market_Default.OpenGui(p, 1);
                p.playSound(p.getLocation(), Sound.BLOCK_CHEST_OPEN, 0.5F, 1.0F);
                /*sender.sendMessage("§8====================§b§l全球贸易市场§8====================");
                sender.sendMessage("§a/gs open §8§l-----§c打开全球贸易市场");
                sender.sendMessage("§a/gs amount §8§l-----§c查看当前最多上架多少个物品");
                sender.sendMessage("§a/gs sell <价格> §8§l-----§c将手持物品以金币形式上架");
                sender.sendMessage("§c价格:§a上架商品的出售价格");
                sender.sendMessage("§c手续费说明:§a免手续费");*/
            }
            if (args.length == 1) {
                if (args[0].equalsIgnoreCase("amount")) {
                    Player p = (Player) sender;
                    sender.sendMessage(prefix + "当前已上架 §e" + getUpMarketAmount(p.getName()) + " §f个物品");
                    sender.sendMessage(prefix + "还可以上架 §e" + (getupSellAmount(p) - getUpMarketAmount(p.getName())) + " §f个物品");
                }
                if (args[0].equalsIgnoreCase("open")) {
                    Player p = (Player) sender;
                    Market_Default.OpenGui(p, 1);
                    p.playSound(p.getLocation(), Sound.BLOCK_CHEST_OPEN, 0.5F, 1.0F);
                }
                if (args[0].equalsIgnoreCase("ceshi") && sender.isOp()) {
                    TimeCheckRunnable.Check_Market_Time();
                }
                if (args[0].equalsIgnoreCase("sell")) {
                    sender.sendMessage(prefix + "正确用法: §a/pdd sell [价格]");
                    return true;
                }
            }
            if (args.length == 2) {
                Player p = (Player) sender;
                ItemStack item = p.getInventory().getItemInHand();
                if (args[0].equalsIgnoreCase("sell")) {
                    if (!DemonAPI.itemIsNull(item)) {
                        if (itemIsBind(item)) {
                            p.sendMessage(prefix + "§c当前物品无法进行交易,请检查是否存在绑定.");
                            return true;
                        }
                        if (item.getAmount() >= 1) {
                            int money = Integer.parseInt(args[1]);
                            if (money < 10) {
                                p.sendMessage(prefix + "商品价格不能低于§6$10金币§f，请重新设置价格.");
                                return true;
                            }
                            if (money >= 100000000) {
                                p.sendMessage(prefix + "上架物品不能高于§6$10,000万§f，请重新设置价格.");
                                return true;
                            }
                            int amount = getupSellAmount(p);
                            if (amount <= 0) {
                                p.sendMessage(prefix + "你需要成为 §2【领域农民】 §f才能使用此命令.");
                                return true;
                            }
                            if (getUpMarketAmount(p.getName()) <= amount) {
                                int tax = (int) (money * 0.02);
                                if (!DemonAPI.hasMoney(p, tax)) {
                                    p.sendMessage(prefix + "你需要先支付§6$" + tax + "§f手续费才能上架.");
                                    return true;
                                }
                                DemonAPI.takeMoney(p, tax);
                                MkEvant.CreateShopItems(p, item, money);
                            } else {
                                sender.sendMessage(prefix + "§c你最多可以在全球贸易行上架 §e" + amount + " §c件商品。§7(提升阶级可增加数量)");
                            }
                        }
                    } else {
                        sender.sendMessage(prefix + "§c请手持物品后再尝试上架。");
                    }
                }
            }
        }
        return false;
    }

    public static int getupSellAmount(Player p) {
        int amount = -1;
        if (p.hasPermission("vip2.use")) {
            amount = 10;
        } else if (p.hasPermission("vip1.use")) {
            amount = 8;
        } else if (p.hasPermission("yuanzu.use")) {
            amount = 8;
        } else if (p.hasPermission("lianjinshi.use")) {
            amount = 6;
        } else if (p.hasPermission("shangren.use")) {
            amount = 4;
        } else if (p.hasPermission("nongmin.use")) {
            amount = 2;
        }
        return amount;
    }

    public static boolean itemIsBind(ItemStack item) {
        boolean butt = false;
        if (!DemonAPI.itemIsLore(item)) {
            for (int i = 0; i < BlackNoItemList.size(); i++) {
                if (item.getItemMeta().getLore().contains(BlackNoItemList.get(i))) {
                    butt = true;
                }
            }
            for (String str : item.getItemMeta().getLore()) {
                if (str.startsWith("§c装备绑定: §e")) {
                    butt = true;
                }
            }
        }

        return butt;
    }

    public static boolean isInt(String s) {
        try {
            Integer.parseInt(s);
        } catch (NumberFormatException nfe) {
            return false;
        }
        return true;
    }

    public static String getTime(String format) {
        Date date = Calendar.getInstance().getTime();
        SimpleDateFormat datatime = new SimpleDateFormat(format);
        return datatime.format(date);
    }

    //获取玩家已上架数量
    public static int getUpMarketAmount(String playName) {
        int amount = 0;
        for (String key : Objects.requireNonNull(main.DataG.getConfigurationSection("Items")).getKeys(false)) {
            String pName = main.DataG.getString("Items." + key + ".Seller");
            assert pName != null;
            if (pName.equalsIgnoreCase(playName)) {
                amount = amount + 1;
            }
        }
        return amount;
    }


    public static File Datafile = new File("plugins/DemonMarket", "Data.yml");
    public static FileConfiguration DataG = YamlConfiguration.loadConfiguration(Datafile);

    public static void saveDataStatsConfig() {
        try {
            main.DataG.save(Datafile);
        } catch (IOException e) {
            e.printStackTrace();
        }
    }


    // 分类管理
    public static File Categoryfile = new File("plugins/DemonMarket", "Category.yml");
    public static FileConfiguration CategoryG = YamlConfiguration.loadConfiguration(Categoryfile);

    public static void saveCategoryConfig() {
        try {
            main.CategoryG.save(Categoryfile);
        } catch (IOException e) {
            e.printStackTrace();
        }
    }
}